/* pernilleGff.c was originally generated by the autoSql program, which also 
 * generated pernilleGff.h and pernilleGff.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "pernilleGff.h"

static char const rcsid[] = "$Id: pernilleGff.c,v 1.1 2004/10/13 21:58:19 aamp Exp $";

void pernilleGffStaticLoad(char **row, struct pernilleGff *ret)
/* Load a row from pernilleGff table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->genome = row[0];
ret->source = row[1];
ret->feat = row[2];
ret->startStop = sqlUnsigned(row[3]);
ret->stopStart = sqlUnsigned(row[4]);
ret->R = atof(row[5]);
strcpy(ret->strand, row[6]);
ret->frame = sqlUnsigned(row[7]);
ret->orf = row[8];
ret->startCodon = row[9];
ret->logOdds = atof(row[10]);
ret->descriptor = row[11];
ret->swissProt = row[12];
ret->annot = row[13];
}

struct pernilleGff *pernilleGffLoad(char **row)
/* Load a pernilleGff from row fetched with select * from pernilleGff
 * from database.  Dispose of this with pernilleGffFree(). */
{
struct pernilleGff *ret;

AllocVar(ret);
ret->genome = cloneString(row[0]);
ret->source = cloneString(row[1]);
ret->feat = cloneString(row[2]);
ret->startStop = sqlUnsigned(row[3]);
ret->stopStart = sqlUnsigned(row[4]);
ret->R = atof(row[5]);
strcpy(ret->strand, row[6]);
ret->frame = sqlUnsigned(row[7]);
ret->orf = cloneString(row[8]);
ret->startCodon = cloneString(row[9]);
ret->logOdds = atof(row[10]);
ret->descriptor = cloneString(row[11]);
ret->swissProt = cloneString(row[12]);
ret->annot = cloneString(row[13]);
return ret;
}

struct pernilleGff *pernilleGffLoadAll(char *fileName) 
/* Load all pernilleGff from a whitespace-separated file.
 * Dispose of this with pernilleGffFreeList(). */
{
struct pernilleGff *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[14];

while (lineFileRow(lf, row))
    {
    el = pernilleGffLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pernilleGff *pernilleGffLoadAllByChar(char *fileName, char chopper) 
/* Load all pernilleGff from a chopper separated file.
 * Dispose of this with pernilleGffFreeList(). */
{
struct pernilleGff *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[14];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = pernilleGffLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pernilleGff *pernilleGffLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all pernilleGff from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with pernilleGffFreeList(). */
{
struct pernilleGff *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = pernilleGffLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void pernilleGffSaveToDb(struct sqlConnection *conn, struct pernilleGff *el, char *tableName, int updateSize)
/* Save pernilleGff as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use pernilleGffSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s','%s','%s',%u,%u,%g,'%s',%u,'%s','%s',%g,'%s','%s','%s')", 
	tableName,  el->genome,  el->source,  el->feat,  el->startStop,  el->stopStart,  el->R,  el->strand,  el->frame,  el->orf,  el->startCodon,  el->logOdds,  el->descriptor,  el->swissProt,  el->annot);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void pernilleGffSaveToDbEscaped(struct sqlConnection *conn, struct pernilleGff *el, char *tableName, int updateSize)
/* Save pernilleGff as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than pernilleGffSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *genome, *source, *feat, *strand, *orf, *startCodon, *descriptor, *swissProt, *annot;
genome = sqlEscapeString(el->genome);
source = sqlEscapeString(el->source);
feat = sqlEscapeString(el->feat);
strand = sqlEscapeString(el->strand);
orf = sqlEscapeString(el->orf);
startCodon = sqlEscapeString(el->startCodon);
descriptor = sqlEscapeString(el->descriptor);
swissProt = sqlEscapeString(el->swissProt);
annot = sqlEscapeString(el->annot);

dyStringPrintf(update, "insert into %s values ( '%s','%s','%s',%u,%u,%g,'%s',%u,'%s','%s',%g,'%s','%s','%s')", 
	tableName,  genome,  source,  feat, el->startStop , el->stopStart , el->R ,  strand, el->frame ,  orf,  startCodon, el->logOdds ,  descriptor,  swissProt,  annot);
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&genome);
freez(&source);
freez(&feat);
freez(&strand);
freez(&orf);
freez(&startCodon);
freez(&descriptor);
freez(&swissProt);
freez(&annot);
}

struct pernilleGff *pernilleGffCommaIn(char **pS, struct pernilleGff *ret)
/* Create a pernilleGff out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pernilleGff */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->genome = sqlStringComma(&s);
ret->source = sqlStringComma(&s);
ret->feat = sqlStringComma(&s);
ret->startStop = sqlUnsignedComma(&s);
ret->stopStart = sqlUnsignedComma(&s);
ret->R = sqlFloatComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
ret->frame = sqlUnsignedComma(&s);
ret->orf = sqlStringComma(&s);
ret->startCodon = sqlStringComma(&s);
ret->logOdds = sqlFloatComma(&s);
ret->descriptor = sqlStringComma(&s);
ret->swissProt = sqlStringComma(&s);
ret->annot = sqlStringComma(&s);
*pS = s;
return ret;
}

void pernilleGffFree(struct pernilleGff **pEl)
/* Free a single dynamically allocated pernilleGff such as created
 * with pernilleGffLoad(). */
{
struct pernilleGff *el;

if ((el = *pEl) == NULL) return;
freeMem(el->genome);
freeMem(el->source);
freeMem(el->feat);
freeMem(el->orf);
freeMem(el->startCodon);
freeMem(el->descriptor);
freeMem(el->swissProt);
freeMem(el->annot);
freez(pEl);
}

void pernilleGffFreeList(struct pernilleGff **pList)
/* Free a list of dynamically allocated pernilleGff's */
{
struct pernilleGff *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pernilleGffFree(&el);
    }
*pList = NULL;
}

void pernilleGffOutput(struct pernilleGff *el, FILE *f, char sep, char lastSep) 
/* Print out pernilleGff.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->genome);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->source);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->feat);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->startStop);
fputc(sep,f);
fprintf(f, "%u", el->stopStart);
fputc(sep,f);
fprintf(f, "%g", el->R);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->frame);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->orf);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->startCodon);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%g", el->logOdds);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->descriptor);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->swissProt);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->annot);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

