/* pernilleGff.h was originally generated by the autoSql program, which also 
 * generated pernilleGff.c and pernilleGff.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef PERNILLEGFF_H
#define PERNILLEGFF_H

#ifndef JKSQL_H
#include "jksql.h"
#endif

#define PERNILLEGFF_NUM_COLS 14

struct pernilleGff
/* GFF format from Pernille's web page */
    {
    struct pernilleGff *next;  /* Next in singly linked list. */
    char *genome;	/* Genome name */
    char *source;	/* Source identifier */
    char *feat;	/* Feature identifier */
    unsigned startStop;	/* Start position in chromosome (1-based) */
    unsigned stopStart;	/* End position in chromosome */
    float R;	/* R value */
    char strand[2];	/* Strand */
    unsigned frame;	/* Frame */
    char *orf;	/* ORF identifier */
    char *startCodon;	/* Start Codon */
    float logOdds;	/* Log odds */
    char *descriptor;	/* EasyGene descriptor */
    char *swissProt;	/* Swiss-Prot match */
    char *annot;	/* Annotation */
    };

void pernilleGffStaticLoad(char **row, struct pernilleGff *ret);
/* Load a row from pernilleGff table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct pernilleGff *pernilleGffLoad(char **row);
/* Load a pernilleGff from row fetched with select * from pernilleGff
 * from database.  Dispose of this with pernilleGffFree(). */

struct pernilleGff *pernilleGffLoadAll(char *fileName);
/* Load all pernilleGff from whitespace-separated file.
 * Dispose of this with pernilleGffFreeList(). */

struct pernilleGff *pernilleGffLoadAllByChar(char *fileName, char chopper);
/* Load all pernilleGff from chopper separated file.
 * Dispose of this with pernilleGffFreeList(). */

#define pernilleGffLoadAllByTab(a) pernilleGffLoadAllByChar(a, '\t');
/* Load all pernilleGff from tab separated file.
 * Dispose of this with pernilleGffFreeList(). */

struct pernilleGff *pernilleGffLoadByQuery(struct sqlConnection *conn, char *query);
/* Load all pernilleGff from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with pernilleGffFreeList(). */

void pernilleGffSaveToDb(struct sqlConnection *conn, struct pernilleGff *el, char *tableName, int updateSize);
/* Save pernilleGff as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use pernilleGffSaveToDbEscaped() */

void pernilleGffSaveToDbEscaped(struct sqlConnection *conn, struct pernilleGff *el, char *tableName, int updateSize);
/* Save pernilleGff as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than pernilleGffSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 

struct pernilleGff *pernilleGffCommaIn(char **pS, struct pernilleGff *ret);
/* Create a pernilleGff out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pernilleGff */

void pernilleGffFree(struct pernilleGff **pEl);
/* Free a single dynamically allocated pernilleGff such as created
 * with pernilleGffLoad(). */

void pernilleGffFreeList(struct pernilleGff **pList);
/* Free a list of dynamically allocated pernilleGff's */

void pernilleGffOutput(struct pernilleGff *el, FILE *f, char sep, char lastSep);
/* Print out pernilleGff.  Separate fields with sep. Follow last field with lastSep. */

#define pernilleGffTabOut(el,f) pernilleGffOutput(el,f,'\t','\n');
/* Print out pernilleGff as a line in a tab-separated file. */

#define pernilleGffCommaOut(el,f) pernilleGffOutput(el,f,',',',');
/* Print out pernilleGff as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* PERNILLEGFF_H */

