/* transMapInfo.h was originally generated by the autoSql program, which also 
 * generated transMapInfo.c and transMapInfo.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef TRANSMAPINFO_H
#define TRANSMAPINFO_H

#define TRANSMAPINFO_NUM_COLS 18

struct transMapInfo
/* information about transMap gene mappings */
    {
    struct transMapInfo *next;  /* Next in singly linked list. */
    char srcDb[13];	/* source db */
    char chains[9];	/* type of chains used for mapping */
    char *srcId;	/* id of original gene */
    char *srcChrom;	/* source chromosome */
    unsigned srcStart;	/* source start location */
    unsigned srcEnd;	/* source end location */
    unsigned srcExonCnt;	/* number of exons in src gene */
    unsigned srcCdsExonCnt;	/* number of CDS exons in src gene */
    unsigned srcBaseCnt;	/* number of bases in src gene */
    unsigned srcCdsBaseCnt;	/* number of CDS bases in src gene */
    char *mappedId;	/* id of mapped gene */
    char *mappedChrom;	/* mapped chromosome */
    unsigned mappedStart;	/* mapped start location */
    unsigned mappedEnd;	/* mapped end location */
    unsigned mappedExonCnt;	/* number of exons mapped */
    unsigned mappedCdsExonCnt;	/* number of CDS exons mapped */
    unsigned mappedBaseCnt;	/* number of bases mapped */
    unsigned mappedCdsBaseCnt;	/* number of CDS bases mapped */
    };

void transMapInfoStaticLoad(char **row, struct transMapInfo *ret);
/* Load a row from transMapInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct transMapInfo *transMapInfoLoad(char **row);
/* Load a transMapInfo from row fetched with select * from transMapInfo
 * from database.  Dispose of this with transMapInfoFree(). */

struct transMapInfo *transMapInfoLoadAll(char *fileName);
/* Load all transMapInfo from whitespace-separated file.
 * Dispose of this with transMapInfoFreeList(). */

struct transMapInfo *transMapInfoLoadAllByChar(char *fileName, char chopper);
/* Load all transMapInfo from chopper separated file.
 * Dispose of this with transMapInfoFreeList(). */

#define transMapInfoLoadAllByTab(a) transMapInfoLoadAllByChar(a, '\t');
/* Load all transMapInfo from tab separated file.
 * Dispose of this with transMapInfoFreeList(). */

struct transMapInfo *transMapInfoCommaIn(char **pS, struct transMapInfo *ret);
/* Create a transMapInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new transMapInfo */

void transMapInfoFree(struct transMapInfo **pEl);
/* Free a single dynamically allocated transMapInfo such as created
 * with transMapInfoLoad(). */

void transMapInfoFreeList(struct transMapInfo **pList);
/* Free a list of dynamically allocated transMapInfo's */

void transMapInfoOutput(struct transMapInfo *el, FILE *f, char sep, char lastSep);
/* Print out transMapInfo.  Separate fields with sep. Follow last field with lastSep. */

#define transMapInfoTabOut(el,f) transMapInfoOutput(el,f,'\t','\n');
/* Print out transMapInfo as a line in a tab-separated file. */

#define transMapInfoCommaOut(el,f) transMapInfoOutput(el,f,',',',');
/* Print out transMapInfo as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* TRANSMAPINFO_H */

