/* chromInfo.c was originally generated by the autoSql program, which also 
 * generated chromInfo.h and chromInfo.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "chromInfo.h"

static char const rcsid[] = "$Id: chromInfo.c,v 1.5 2006/07/26 04:16:38 baertsch Exp $";

void chromInfoStaticLoad(char **row, struct chromInfo *ret)
/* Load a row from chromInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->chrom = row[0];
ret->size = sqlUnsigned(row[1]);
ret->fileName = row[2];
}

struct chromInfo *chromInfoLoad(char **row)
/* Load a chromInfo from row fetched with select * from chromInfo
 * from database.  Dispose of this with chromInfoFree(). */
{
struct chromInfo *ret;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->size = sqlUnsigned(row[1]);
ret->fileName = cloneString(row[2]);
return ret;
}

struct chromInfo *chromInfoLoadAll(char *fileName) 
/* Load all chromInfo from a whitespace-separated file.
 * Dispose of this with chromInfoFreeList(). */
{
struct chromInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileRow(lf, row))
    {
    el = chromInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct chromInfo *chromInfoLoadAllByChar(char *fileName, char chopper) 
/* Load all chromInfo from a chopper separated file.
 * Dispose of this with chromInfoFreeList(). */
{
struct chromInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = chromInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct chromInfo *chromInfoCommaIn(char **pS, struct chromInfo *ret)
/* Create a chromInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new chromInfo */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->size = sqlUnsignedComma(&s);
ret->fileName = sqlStringComma(&s);
*pS = s;
return ret;
}

void chromInfoFree(struct chromInfo **pEl)
/* Free a single dynamically allocated chromInfo such as created
 * with chromInfoLoad(). */
{
struct chromInfo *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->fileName);
freez(pEl);
}

void chromInfoFreeList(struct chromInfo **pList)
/* Free a list of dynamically allocated chromInfo's */
{
struct chromInfo *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    chromInfoFree(&el);
    }
*pList = NULL;
}

void chromInfoOutput(struct chromInfo *el, FILE *f, char sep, char lastSep) 
/* Print out chromInfo.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->size);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->fileName);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

