/* gencodeGeneClass.c was originally generated by the autoSql program, which also 
 * generated gencodeGeneClass.h and gencodeGeneClass.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "gencodeGeneClass.h"

static char const rcsid[] = "$Id: gencodeGeneClass.c,v 1.2 2005/09/20 22:17:33 baertsch Exp $";

void gencodeGeneClassStaticLoad(char **row, struct gencodeGeneClass *ret)
/* Load a row from gencodeGeneClass table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->name = row[0];
ret->class = row[1];
}

struct gencodeGeneClass *gencodeGeneClassLoad(char **row)
/* Load a gencodeGeneClass from row fetched with select * from gencodeGeneClass
 * from database.  Dispose of this with gencodeGeneClassFree(). */
{
struct gencodeGeneClass *ret;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->class = cloneString(row[1]);
return ret;
}

struct gencodeGeneClass *gencodeGeneClassLoadAll(char *fileName) 
/* Load all gencodeGeneClass from a whitespace-separated file.
 * Dispose of this with gencodeGeneClassFreeList(). */
{
struct gencodeGeneClass *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = gencodeGeneClassLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct gencodeGeneClass *gencodeGeneClassLoadAllByChar(char *fileName, char chopper) 
/* Load all gencodeGeneClass from a chopper separated file.
 * Dispose of this with gencodeGeneClassFreeList(). */
{
struct gencodeGeneClass *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = gencodeGeneClassLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct gencodeGeneClass *gencodeGeneClassLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all gencodeGeneClass from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with gencodeGeneClassFreeList(). */
{
struct gencodeGeneClass *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = gencodeGeneClassLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void gencodeGeneClassSaveToDb(struct sqlConnection *conn, struct gencodeGeneClass *el, char *tableName, int updateSize)
/* Save gencodeGeneClass as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use gencodeGeneClassSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  el->name,  el->class);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void gencodeGeneClassSaveToDbEscaped(struct sqlConnection *conn, struct gencodeGeneClass *el, char *tableName, int updateSize)
/* Save gencodeGeneClass as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than gencodeGeneClassSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *name, *class;
name = sqlEscapeString(el->name);
class = sqlEscapeString(el->class);

dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  name,  class);
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&name);
freez(&class);
}

struct gencodeGeneClass *gencodeGeneClassCommaIn(char **pS, struct gencodeGeneClass *ret)
/* Create a gencodeGeneClass out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new gencodeGeneClass */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->class = sqlStringComma(&s);
*pS = s;
return ret;
}

void gencodeGeneClassFree(struct gencodeGeneClass **pEl)
/* Free a single dynamically allocated gencodeGeneClass such as created
 * with gencodeGeneClassLoad(). */
{
struct gencodeGeneClass *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->class);
freez(pEl);
}

void gencodeGeneClassFreeList(struct gencodeGeneClass **pList)
/* Free a list of dynamically allocated gencodeGeneClass's */
{
struct gencodeGeneClass *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    gencodeGeneClassFree(&el);
    }
*pList = NULL;
}

void gencodeGeneClassOutput(struct gencodeGeneClass *el, FILE *f, char sep, char lastSep) 
/* Print out gencodeGeneClass.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->class);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

