/* lsSnpFunction.c was originally generated by the autoSql program, which also 
 * generated lsSnpFunction.h and lsSnpFunction.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "lsSnpFunction.h"

static char const rcsid[] = "$Id: lsSnpFunction.c,v 1.1 2005/12/12 06:43:46 daryl Exp $";

void lsSnpFunctionStaticLoad(char **row, struct lsSnpFunction *ret)
/* Load a row from lsSnpFunction table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->uniprotId = row[0];
ret->rsId = row[1];
}

struct lsSnpFunction *lsSnpFunctionLoad(char **row)
/* Load a lsSnpFunction from row fetched with select * from lsSnpFunction
 * from database.  Dispose of this with lsSnpFunctionFree(). */
{
struct lsSnpFunction *ret;

AllocVar(ret);
ret->uniprotId = cloneString(row[0]);
ret->rsId = cloneString(row[1]);
return ret;
}

struct lsSnpFunction *lsSnpFunctionLoadAll(char *fileName) 
/* Load all lsSnpFunction from a whitespace-separated file.
 * Dispose of this with lsSnpFunctionFreeList(). */
{
struct lsSnpFunction *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = lsSnpFunctionLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct lsSnpFunction *lsSnpFunctionLoadAllByChar(char *fileName, char chopper) 
/* Load all lsSnpFunction from a chopper separated file.
 * Dispose of this with lsSnpFunctionFreeList(). */
{
struct lsSnpFunction *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = lsSnpFunctionLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct lsSnpFunction *lsSnpFunctionLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all lsSnpFunction from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with lsSnpFunctionFreeList(). */
{
struct lsSnpFunction *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = lsSnpFunctionLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void lsSnpFunctionSaveToDb(struct sqlConnection *conn, struct lsSnpFunction *el, char *tableName, int updateSize)
/* Save lsSnpFunction as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use lsSnpFunctionSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  el->uniprotId,  el->rsId);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void lsSnpFunctionSaveToDbEscaped(struct sqlConnection *conn, struct lsSnpFunction *el, char *tableName, int updateSize)
/* Save lsSnpFunction as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than lsSnpFunctionSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *uniprotId, *rsId;
uniprotId = sqlEscapeString(el->uniprotId);
rsId = sqlEscapeString(el->rsId);

dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  uniprotId,  rsId);
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&uniprotId);
freez(&rsId);
}

struct lsSnpFunction *lsSnpFunctionCommaIn(char **pS, struct lsSnpFunction *ret)
/* Create a lsSnpFunction out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new lsSnpFunction */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->uniprotId = sqlStringComma(&s);
ret->rsId = sqlStringComma(&s);
*pS = s;
return ret;
}

void lsSnpFunctionFree(struct lsSnpFunction **pEl)
/* Free a single dynamically allocated lsSnpFunction such as created
 * with lsSnpFunctionLoad(). */
{
struct lsSnpFunction *el;

if ((el = *pEl) == NULL) return;
freeMem(el->uniprotId);
freeMem(el->rsId);
freez(pEl);
}

void lsSnpFunctionFreeList(struct lsSnpFunction **pList)
/* Free a list of dynamically allocated lsSnpFunction's */
{
struct lsSnpFunction *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    lsSnpFunctionFree(&el);
    }
*pList = NULL;
}

void lsSnpFunctionOutput(struct lsSnpFunction *el, FILE *f, char sep, char lastSep) 
/* Print out lsSnpFunction.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->uniprotId);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->rsId);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

