/* lsSnpStructure.c was originally generated by the autoSql program, which also 
 * generated lsSnpStructure.h and lsSnpStructure.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "lsSnpStructure.h"

static char const rcsid[] = "$Id: lsSnpStructure.c,v 1.1 2005/12/12 06:43:46 daryl Exp $";

void lsSnpStructureStaticLoad(char **row, struct lsSnpStructure *ret)
/* Load a row from lsSnpStructure table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->uniprotId = row[0];
ret->rsId = row[1];
}

struct lsSnpStructure *lsSnpStructureLoad(char **row)
/* Load a lsSnpStructure from row fetched with select * from lsSnpStructure
 * from database.  Dispose of this with lsSnpStructureFree(). */
{
struct lsSnpStructure *ret;

AllocVar(ret);
ret->uniprotId = cloneString(row[0]);
ret->rsId = cloneString(row[1]);
return ret;
}

struct lsSnpStructure *lsSnpStructureLoadAll(char *fileName) 
/* Load all lsSnpStructure from a whitespace-separated file.
 * Dispose of this with lsSnpStructureFreeList(). */
{
struct lsSnpStructure *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = lsSnpStructureLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct lsSnpStructure *lsSnpStructureLoadAllByChar(char *fileName, char chopper) 
/* Load all lsSnpStructure from a chopper separated file.
 * Dispose of this with lsSnpStructureFreeList(). */
{
struct lsSnpStructure *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = lsSnpStructureLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct lsSnpStructure *lsSnpStructureLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all lsSnpStructure from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with lsSnpStructureFreeList(). */
{
struct lsSnpStructure *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = lsSnpStructureLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void lsSnpStructureSaveToDb(struct sqlConnection *conn, struct lsSnpStructure *el, char *tableName, int updateSize)
/* Save lsSnpStructure as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use lsSnpStructureSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  el->uniprotId,  el->rsId);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void lsSnpStructureSaveToDbEscaped(struct sqlConnection *conn, struct lsSnpStructure *el, char *tableName, int updateSize)
/* Save lsSnpStructure as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than lsSnpStructureSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *uniprotId, *rsId;
uniprotId = sqlEscapeString(el->uniprotId);
rsId = sqlEscapeString(el->rsId);

dyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  uniprotId,  rsId);
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&uniprotId);
freez(&rsId);
}

struct lsSnpStructure *lsSnpStructureCommaIn(char **pS, struct lsSnpStructure *ret)
/* Create a lsSnpStructure out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new lsSnpStructure */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->uniprotId = sqlStringComma(&s);
ret->rsId = sqlStringComma(&s);
*pS = s;
return ret;
}

void lsSnpStructureFree(struct lsSnpStructure **pEl)
/* Free a single dynamically allocated lsSnpStructure such as created
 * with lsSnpStructureLoad(). */
{
struct lsSnpStructure *el;

if ((el = *pEl) == NULL) return;
freeMem(el->uniprotId);
freeMem(el->rsId);
freez(pEl);
}

void lsSnpStructureFreeList(struct lsSnpStructure **pList)
/* Free a list of dynamically allocated lsSnpStructure's */
{
struct lsSnpStructure *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    lsSnpStructureFree(&el);
    }
*pList = NULL;
}

void lsSnpStructureOutput(struct lsSnpStructure *el, FILE *f, char sep, char lastSep) 
/* Print out lsSnpStructure.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->uniprotId);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->rsId);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

