/* transMapInfo.c was originally generated by the autoSql program, which also 
 * generated transMapInfo.h and transMapInfo.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "transMapInfo.h"

static char const rcsid[] = "$Id: transMapInfo.c,v 1.2 2006/06/11 19:40:55 markd Exp $";

void transMapInfoStaticLoad(char **row, struct transMapInfo *ret)
/* Load a row from transMapInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

strcpy(ret->srcDb, row[0]);
strcpy(ret->chains, row[1]);
ret->srcId = row[2];
ret->srcChrom = row[3];
ret->srcStart = sqlUnsigned(row[4]);
ret->srcEnd = sqlUnsigned(row[5]);
ret->srcExonCnt = sqlUnsigned(row[6]);
ret->srcCdsExonCnt = sqlUnsigned(row[7]);
ret->srcBaseCnt = sqlUnsigned(row[8]);
ret->srcCdsBaseCnt = sqlUnsigned(row[9]);
ret->mappedId = row[10];
ret->mappedChrom = row[11];
ret->mappedStart = sqlUnsigned(row[12]);
ret->mappedEnd = sqlUnsigned(row[13]);
ret->mappedExonCnt = sqlUnsigned(row[14]);
ret->mappedCdsExonCnt = sqlUnsigned(row[15]);
ret->mappedBaseCnt = sqlUnsigned(row[16]);
ret->mappedCdsBaseCnt = sqlUnsigned(row[17]);
}

struct transMapInfo *transMapInfoLoad(char **row)
/* Load a transMapInfo from row fetched with select * from transMapInfo
 * from database.  Dispose of this with transMapInfoFree(). */
{
struct transMapInfo *ret;

AllocVar(ret);
strcpy(ret->srcDb, row[0]);
strcpy(ret->chains, row[1]);
ret->srcId = cloneString(row[2]);
ret->srcChrom = cloneString(row[3]);
ret->srcStart = sqlUnsigned(row[4]);
ret->srcEnd = sqlUnsigned(row[5]);
ret->srcExonCnt = sqlUnsigned(row[6]);
ret->srcCdsExonCnt = sqlUnsigned(row[7]);
ret->srcBaseCnt = sqlUnsigned(row[8]);
ret->srcCdsBaseCnt = sqlUnsigned(row[9]);
ret->mappedId = cloneString(row[10]);
ret->mappedChrom = cloneString(row[11]);
ret->mappedStart = sqlUnsigned(row[12]);
ret->mappedEnd = sqlUnsigned(row[13]);
ret->mappedExonCnt = sqlUnsigned(row[14]);
ret->mappedCdsExonCnt = sqlUnsigned(row[15]);
ret->mappedBaseCnt = sqlUnsigned(row[16]);
ret->mappedCdsBaseCnt = sqlUnsigned(row[17]);
return ret;
}

struct transMapInfo *transMapInfoLoadAll(char *fileName) 
/* Load all transMapInfo from a whitespace-separated file.
 * Dispose of this with transMapInfoFreeList(). */
{
struct transMapInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[18];

while (lineFileRow(lf, row))
    {
    el = transMapInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct transMapInfo *transMapInfoLoadAllByChar(char *fileName, char chopper) 
/* Load all transMapInfo from a chopper separated file.
 * Dispose of this with transMapInfoFreeList(). */
{
struct transMapInfo *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[18];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = transMapInfoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct transMapInfo *transMapInfoCommaIn(char **pS, struct transMapInfo *ret)
/* Create a transMapInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new transMapInfo */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
sqlFixedStringComma(&s, ret->srcDb, sizeof(ret->srcDb));
sqlFixedStringComma(&s, ret->chains, sizeof(ret->chains));
ret->srcId = sqlStringComma(&s);
ret->srcChrom = sqlStringComma(&s);
ret->srcStart = sqlUnsignedComma(&s);
ret->srcEnd = sqlUnsignedComma(&s);
ret->srcExonCnt = sqlUnsignedComma(&s);
ret->srcCdsExonCnt = sqlUnsignedComma(&s);
ret->srcBaseCnt = sqlUnsignedComma(&s);
ret->srcCdsBaseCnt = sqlUnsignedComma(&s);
ret->mappedId = sqlStringComma(&s);
ret->mappedChrom = sqlStringComma(&s);
ret->mappedStart = sqlUnsignedComma(&s);
ret->mappedEnd = sqlUnsignedComma(&s);
ret->mappedExonCnt = sqlUnsignedComma(&s);
ret->mappedCdsExonCnt = sqlUnsignedComma(&s);
ret->mappedBaseCnt = sqlUnsignedComma(&s);
ret->mappedCdsBaseCnt = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

void transMapInfoFree(struct transMapInfo **pEl)
/* Free a single dynamically allocated transMapInfo such as created
 * with transMapInfoLoad(). */
{
struct transMapInfo *el;

if ((el = *pEl) == NULL) return;
freeMem(el->srcId);
freeMem(el->srcChrom);
freeMem(el->mappedId);
freeMem(el->mappedChrom);
freez(pEl);
}

void transMapInfoFreeList(struct transMapInfo **pList)
/* Free a list of dynamically allocated transMapInfo's */
{
struct transMapInfo *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    transMapInfoFree(&el);
    }
*pList = NULL;
}

void transMapInfoOutput(struct transMapInfo *el, FILE *f, char sep, char lastSep) 
/* Print out transMapInfo.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->srcDb);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chains);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->srcId);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->srcChrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->srcStart);
fputc(sep,f);
fprintf(f, "%u", el->srcEnd);
fputc(sep,f);
fprintf(f, "%u", el->srcExonCnt);
fputc(sep,f);
fprintf(f, "%u", el->srcCdsExonCnt);
fputc(sep,f);
fprintf(f, "%u", el->srcBaseCnt);
fputc(sep,f);
fprintf(f, "%u", el->srcCdsBaseCnt);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->mappedId);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->mappedChrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->mappedStart);
fputc(sep,f);
fprintf(f, "%u", el->mappedEnd);
fputc(sep,f);
fprintf(f, "%u", el->mappedExonCnt);
fputc(sep,f);
fprintf(f, "%u", el->mappedCdsExonCnt);
fputc(sep,f);
fprintf(f, "%u", el->mappedBaseCnt);
fputc(sep,f);
fprintf(f, "%u", el->mappedCdsBaseCnt);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

